using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Text;

namespace I2CDotNet
{
    enum MoveMethod
    {
        /// <summary>
        /// The start of the file
        /// </summary>
        FileBeginning,
        /// <summary>
        /// The current file pointer position
        /// </summary>
        CurrentPosition,
        /// <summary>
        /// The end of the file
        /// </summary>
        FileEnd
    }
    class NativeMethods
    {
        [DllImport("coredll.dll", EntryPoint = "CreateFile", SetLastError = true)]
        public static extern IntPtr CreateFile
        (
            String lpFileName,
            UInt32 dwDesiredAccess,
            UInt32 dwShareMode,
            IntPtr lpSecurityAttributes,
            UInt32 dwCreationDisposition,
            UInt32 dwFlagsAndAttributes,
            IntPtr hTemplateFile
        );

        [DllImport("Coredll.dll")]
        public static extern int CloseHandle(IntPtr handle);

        [DllImport("coredll.dll", SetLastError = true)]
        public static extern bool DeviceIoControl
        (
            IntPtr hDevice,
            uint dwIoControlCode,
            IntPtr lpInBuffer,
            uint nInBufferSize,
            IntPtr lpOutBuffer,
            uint nOutBufferSize,
            ref uint lpBytesReturned,
            IntPtr lpOverlapped
        );

        [DllImport("coredll.dll", EntryPoint = "SetFilePointer", SetLastError = true)]
        public static extern int SetFilePointerCE(
            IntPtr hFile,
            int lDistanceToMove,
            int lpDistanceToMoveHigh,
            MoveMethod dwMoveMethod);

        [DllImport("coredll.dll", EntryPoint = "ReadFile", SetLastError = true)]
        public static extern int ReadFileCE(
            IntPtr hFile,
            byte[] lpBuffer,
            int nNumberOfBytesToRead,
            ref int lpNumberOfBytesRead,
            IntPtr lpOverlapped);

        [DllImport("coredll.dll", EntryPoint = "WriteFile", SetLastError = true)]
        public static extern int WriteFileCE(
            IntPtr hFile,
            Byte[] lpBuffer,
            int nNumberOfBytesToWrite,
            ref int lpNumberOfBytesWritten,
            IntPtr lpOverlapped);
        
        // IOCTL creation specific constants
        internal const uint METHOD_BUFFERED = 0;
        internal const uint FILE_WRITE_ACCESS = 0x0002;
        internal const uint FILE_DEVICE_UNKNOWN = 0x00000022;
        internal const uint FILE_ANY_ACCESS = 0;
        
        public static uint CTL_CODE_DEVICE_UNKNOWN(uint uiFunction)
        {
            return ((FILE_DEVICE_UNKNOWN << 16) | (FILE_ANY_ACCESS << 14) | ((uiFunction) << 2) | METHOD_BUFFERED);
        }
    }
}
